#include <vector>

#include <stdio.h>

int main(int argc, char **argv) {
	FILE *f = fopen(argv[1], "rb");
	int c;
	int bits_left = 0;
	char control;
	std::vector<char> file;

	int skip = argc>3 ? atoi(argv[3]) : 4;

	fseek(f, skip, SEEK_CUR);

	file.resize(4096);
	memset(&file[0], 0, 4096);

	while(EOF != (c = getc(f))) {
		if (!bits_left) {
			control = c;
			bits_left = 8;
		} else {
			if (control & 0x01) {
				file.push_back(c);
			} else {
				int d;

				d = getc(f);
				if (EOF == d)
					break;

				int length = (d & 15) + 3;
				int siz = file.size();
				int offset = siz - ((siz - 18 - ((d>>4)*256+c)) & 0xfff);

				file.resize(siz + length);

				for(int i=0; i<length; ++i)
					file[siz+i] = file[offset+i];
			}

			control >>= 1;
			--bits_left;
		}
	}

	FILE *f2 = fopen(argv[2], "wb");

	fwrite(&file[4096], file.size() - 4096, 1, f2);

	fclose(f2);

	return 0;
}
